<?php
namespace Teknisa\SUP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

use Teknisa\SUP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services\JWT;

class LoginByToken{
    
    public function setLoginByToken($request, $response){
        
        $userData = $request->getRow();
        
        JWT::unsetSessionCookie("approveapp");
        $token = JWT::generateToken(array(
            "EMAIL" => $userData['email'],
            "PS" => $userData['password'],
            "NRORG" => $userData['nrorg']
        ));
        JWT::setSessionCookie("approveapp", $token, 0);
        
        $response->addDataSet(new DataSet('token', [$token]));
    }
    
    public function getLoginByToken($request, $response){
        
        $token = isset( $_COOKIE["approveapp"] ) ? $_COOKIE["approveapp"] : $request->getRow()['token'];
        
        if ($token && JWT::validateToken($token, 'approveapp')) {
            $response->addDataSet(new DataSet('user', JWT::getTokenData($token)));
        }else{
            $response->setError(new Error("Sessão automática inválida favor re-logar!", 500));
        }
    }
  
}